<?php
namespace Bairwell\Paypal\Reconciliation;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2012-11-12 at 17:50:01.
 */
class InTest extends \PHPUnit_Framework_TestCase
{

    public function testConstants() {
        $this->assertEquals('Date, Time, Time Zone, Name, Type, Status, Currency, Gross, Fee, Net, From Email Address, To Email Address, Transaction ID, Address Status, Item Title, Item ID, Reference Txn ID, Invoice Number, Receipt ID, Balance, ',In::EXPECTED_HEADERS);
        $this->assertEquals(0,In::COLUMN_DATE);
        $this->assertEquals(1,In::COLUMN_TIME);
        $this->assertEquals(2,In::COLUMN_TIMEZONE);
        $this->assertEquals(3,In::COLUMN_NAME);
        $this->assertEquals(4,In::COLUMN_TYPE);
        $this->assertEquals(5,In::COLUMN_STATUS);
        $this->assertEquals(6,In::COLUMN_CURRENCY);
        $this->assertEquals(7,In::COLUMN_GROSS);
        $this->assertEquals(8,In::COLUMN_FEE);
        $this->assertEquals(9,In::COLUMN_NET);
        $this->assertEquals(10,In::COLUMN_FROMEMAILADDRESS);
        $this->assertEquals(11,In::COLUMN_TOEMAILADDRESS);
        $this->assertEquals(12,In::COLUMN_TRANSACTIONID);
        $this->assertEquals(13,In::COLUMN_ADDRESSSTATUS);
        $this->assertEquals(14,In::COLUMN_ITEMTITLE);
        $this->assertEquals(15,In::COLUMN_ITEMID);
        $this->assertEquals(16,In::COLUMN_REFERENCETRANSACTIONID);
        $this->assertEquals(17,In::COLUMN_INVOICENUMBER);
        $this->assertEquals(18,In::COLUMN_RECEIPTID);
        $this->assertEquals(19,In::COLUMN_BALANCE);
    }

    /**
     * @covers Bairwell\Paypal\Reconciliation\In::construct
     * @covers Bairwell\Paypal\Reconciliation\In::get_date
     * * @covers Bairwell\Paypal\Reconciliation\In::get_time
     * * @covers Bairwell\Paypal\Reconciliation\In::get_timezone
     * * @covers Bairwell\Paypal\Reconciliation\In::get_name
     * * @covers Bairwell\Paypal\Reconciliation\In::get_status
     * * @covers Bairwell\Paypal\Reconciliation\In::get_currency
     * * @covers Bairwell\Paypal\Reconciliation\In::get_gross
     * * @covers Bairwell\Paypal\Reconciliation\In::get_net
     * * @covers Bairwell\Paypal\Reconciliation\In::get_fee
     * * @covers Bairwell\Paypal\Reconciliation\In::get_fromEmail
     * * @covers Bairwell\Paypal\Reconciliation\In::get_transactionid
     * * @covers Bairwell\Paypal\Reconciliation\In::get_relatedTransaction
     * * @covers Bairwell\Paypal\Reconciliation\In::get_invoiceNumber
     * * @covers Bairwell\Paypal\Reconciliation\In::get_balance
     */
    public function testConstruct() {
        $line='21/10/2012,08:36:44,BST,Person 6,Shopping Cart Payment Received,Completed,GBP,35.67,-1.59,34.08,email_4@example.com,';
        $line.='email_2@example.com,38D52F69D5DCC83E6,Confirmed,Item name 2,,X123456Y,Item name 3,,224.41,';
        $data=explode(',',$line);
        $object=new In($data);
        $this->assertEquals('21/10/2012',$object->get_date());
        $this->assertEquals('08:36:44',$object->get_time());
        $this->assertEquals('BST',$object->get_timezone());
        $this->assertEquals('Person 6',$object->get_name());
        $this->assertEquals('Shopping Cart Payment Received',$object->get_type());
        $this->assertEquals('Completed',$object->get_status());
        $this->assertEquals('GBP',$object->get_currency());
        $this->assertEquals('35.67',$object->get_gross());
        $this->assertEquals('1.59',$object->get_fee());
        $this->assertEquals('34.08',$object->get_net());
        $this->assertEquals('email_4@example.com',$object->get_fromEmail());
        $this->assertEquals('38D52F69D5DCC83E6',$object->get_transactionId());
        $this->assertEquals('X123456Y',$object->get_relatedTransaction());
        $this->assertEquals('Item name 3',$object->get_invoiceNumber());
        $this->assertEquals('224.41',$object->get_balance());
    }

    /**
     * Check bad dates are rejected
     * @covers Bairwell\Paypal\Reconciliation\In::construct
     */
    public function testConstruct_BadDate() {
        $dates=array('00/10/2012','32/10/2012','10/00/2012','10/13/2012','10/10/1980','10/10/2030');
        $line='X,08:36:44,BST,Person 6,Shopping Cart Payment Received,Completed,GBP,35.67,-1.59,34.08,email_4@example.com,';
        $line.='email_2@example.com,38D52F69D5DCC83E6,Confirmed,Item name 2,,X123456Y,Item name 3,,224.41,';
        $data=explode(',',$line);
        foreach ($dates as $date) {
            $data[0]=$date;
        $emess='[No exception raised]';
        try {
        $object=new In($data);
        } catch (Exception $e) {
            $emess=$e->getMessage();
        } catch (\Exception $e) {
            $emess='Wrong exception type: '.$e->getMessage();
        }
        $this->assertEquals('Invalid date: '.$date,$emess);
        }
    }

    /**
     * Check bad times are rejected
     * @covers Bairwell\Paypal\Reconciliation\In::construct
     */
    public function testConstruct_BadTime() {
        $times=array('-01:00','24:00','12:61');
        $line='01/01/2012,08:36:44,BST,Person 6,Shopping Cart Payment Received,Completed,GBP,35.67,-1.59,34.08,email_4@example.com,';
        $line.='email_2@example.com,38D52F69D5DCC83E6,Confirmed,Item name 2,,X123456Y,Item name 3,,224.41,';
        $data=explode(',',$line);
        foreach ($times as $time) {
            $data[1]=$time;
            $emess='[No exception raised]';
            try {
                $object=new In($data);
            } catch (Exception $e) {
                $emess=$e->getMessage();
            } catch (\Exception $e) {
                $emess='Wrong exception type: '.$e->getMessage();
            }
            $this->assertEquals('Invalid time: '.$time,$emess);
        }
    }

    /**
     * Check good times are accepted
     * @covers Bairwell\Paypal\Reconciliation\In::construct
     */
    public function testConstruct_GoodTimes() {
        $times=array('14:23:46','14:23:00','11:59:23','10:01:12','10:00:00','00:00:00','00:10:23','01:23:00','23:59:14','23:00:59');
        $line='01/01/2012,08:36:44,BST,Person 6,Shopping Cart Payment Received,Completed,GBP,35.67,-1.59,34.08,email_4@example.com,';
        $line.='email_2@example.com,38D52F69D5DCC83E6,Confirmed,Item name 2,,X123456Y,Item name 3,,224.41,';
        $data=explode(',',$line);
        foreach ($times as $time) {
            $data[1]=$time;
                $object=new In($data);
            $this->assertEquals($time,$object->get_time());
        }
    }

    /**
     * Check bad currencies are rejected
     * @covers Bairwell\Paypal\Reconciliation\In::construct
     */
    public function testConstruct_BadCurriences() {
        $times=array('XYZ','KERWE','PET','gbp');
        $line='01/01/2012,08:36:44,BST,Person 6,Shopping Cart Payment Received,Completed,GBP,35.67,-1.59,34.08,email_4@example.com,';
        $line.='email_2@example.com,38D52F69D5DCC83E6,Confirmed,Item name 2,,X123456Y,Item name 3,,224.41,';
        $data=explode(',',$line);
        foreach ($times as $time) {
            $data[6]=$time;
            $emess='[No exception raised]';
            try {
                $object=new In($data);
            } catch (Exception $e) {
                $emess=$e->getMessage();
            } catch (\Exception $e) {
                $emess='Wrong exception type: '.$e->getMessage();
            }
            $this->assertEquals('Invalid currency: '.$time,$emess);
        }
    }

    /**
     * Check good currencies are accepted
     * @covers Bairwell\Paypal\Reconciliation\In::construct
     */
    public function testConstruct_GoodCurrencies() {
        $times=array('GBP','EUR','JPN','USD');
        $line='01/01/2012,08:36:44,BST,Person 6,Shopping Cart Payment Received,Completed,GBP,35.67,-1.59,34.08,email_4@example.com,';
        $line.='email_2@example.com,38D52F69D5DCC83E6,Confirmed,Item name 2,,X123456Y,Item name 3,,224.41,';
        $data=explode(',',$line);
        foreach ($times as $time) {
            $data[6]=$time;
            $object=new In($data);
            $this->assertEquals($time,$object->get_currency());
        }
    }

    /**
     * Check good gross figures are accepted
     * @covers Bairwell\Paypal\Reconciliation\In::construct
     * @todo   Implement
     **/
    public function testConstruct_GoodGross() {

    }
    /**
     * Check bad gross figures are rjected
     * @covers Bairwell\Paypal\Reconciliation\In::construct
     * @todo   Implement
     **/
    public function testConstruct_BadGross() {

    }
    /**
     * Check good net figures are accepted
     * @covers Bairwell\Paypal\Reconciliation\In::construct
     * @todo   Implement
     **/
    public function testConstruct_GoodNet() {

    }
    /**
     * Check bad balance figures are rejected
     * @covers Bairwell\Paypal\Reconciliation\In::construct
     * @todo   Implement
     **/
    public function testConstruct_BadNet() {

    }
    /**
     * Check good balance figures are accepted
     * @covers Bairwell\Paypal\Reconciliation\In::construct
     * @todo   Implement
     **/
    public function testConstruct_GoodBalance() {

    }
    /**
     * Check bad balance figures are rejected
     * @covers Bairwell\Paypal\Reconciliation\In::construct
     * @todo   Implement
     **/
    public function testConstruct_BadBalance() {

    }
    /**
     * Check conversions work
     * @covers Bairwell\Paypal\Reconciliation\In::construct
     * @todo   Implement
     **/
    public function testConstruct_Conversions() {

    }
}
